function Bipods = Bipods(Rectangles, wordlength)
%%%Computes all Bipods from the rectangles.
%%%Output at [a,b,0,0] where a,b are the oriented rectangles.

Bipods = [0,0,0,0];

s_l_rect = size(Rectangles);
l_rect = s_l_rect(1);
for i1=1:l_rect
   r1_temp = Rectangles(i1,:);
   for sign1=-1:2:1
        %%%for every rectangle r1_temp and orientation sign1:
    for i2 = (i1+1):l_rect
        r2_temp = Rectangles(i2,:);
        for sign2 = -1:2:1
        %%%Check if r1_temp with orientation sign1 is following r2_temp with
        %%%orientation sign2 and that r2_temp with orientation sign2 is
        %%%follwing r1_temp with orientation sign1.
        
            if(following_rectangle(r1_temp, sign1, r2_temp, sign2, wordlength)==1)
                %%%r2_temp with orientation sign2 follows r1_temp with
                %%%orienation sign1
                if(following_rectangle(r2_temp, sign2, r1_temp, sign1, wordlength)==1)
                %%%r1_temp with orientation sign1 follows r2_temp with
                %%%orienation sign2
                %%%hence: found bipod!
                bipod_temp = [sign1*i1, sign2*i2, 0,0];
                Bipods = [Bipods;bipod_temp];
                end
            end
        end
    end
   end
end
      
Bipods = Bipods(2:end,:);

end
 


