function [l_max,Aequ,bequ,lb]= Linear_Programming_Problem(R,RP,Bipod,Tripod,o_Tripod,do_Tripod,wordlength,l1,degree4)

%%%%Set up the linear programming problem for lallop with arbitrary vertex
%%%%size here.

%%%%Encoding: The vector which we will be optimising has the form
%%%%[Bipod;Tripod;o_Tripod;do_Tripod]

%%%%Contraints will be matching up the Rectangles and the Rectangle Pairs!
s_l_R = size(R);
l_R = s_l_R(1);
s_l_RP = size(RP);
l_RP = s_l_RP(1);
s_l_Bipod = size(Bipod);
l_Bipod = s_l_Bipod(1);
s_l_Tripod = size(Tripod);
l_Tripod = s_l_Tripod(1);
s_l_o_Tripod = size(o_Tripod);
l_o_Tripod = s_l_o_Tripod(1);



if degree4==0
    s_l_do_Tripod = size(do_Tripod);
    l_do_Tripod = s_l_do_Tripod(1);
else
    l_do_Tripod = 0;
end

%%%%the vector we try to minimize/maximize has length
%%%%l_Bipd+l_Tripd+l_o_Tripd+l_o_Quadropod.

h_size_matrix = l_Bipod+l_Tripod+l_o_Tripod+l_do_Tripod;
v_size_matrix = l_R + l_RP;
Aequ = zeros(v_size_matrix, h_size_matrix);

%%%now: set up the coefficients of Aequ!

%%%Bipod Part
for i_bipod=1:l_Bipod
    Aequ(abs(Bipod(i_bipod,1)),i_bipod)=sign_help(Bipod(i_bipod,1));
    Aequ(abs(Bipod(i_bipod,2)),i_bipod)=sign_help(Bipod(i_bipod,2));
end


%%%Tripod Part
for i_tripod=1:l_Tripod
    Aequ(abs(Tripod(i_tripod,1)),i_tripod+ l_Bipod)= ...
        Aequ(abs(Tripod(i_tripod,1)),i_tripod+ l_Bipod) + sign_help(Tripod(i_tripod,1));
    Aequ(abs(Tripod(i_tripod,2)),i_tripod+ l_Bipod)=...
        Aequ(abs(Tripod(i_tripod,2)),i_tripod+ l_Bipod) + sign_help(Tripod(i_tripod,2));
    Aequ(abs(Tripod(i_tripod,3)),i_tripod+ l_Bipod)= ...
        Aequ(abs(Tripod(i_tripod,3)),i_tripod+ l_Bipod) + sign_help(Tripod(i_tripod,3));
end

%%%open_Tripod Part
for i_o_tripod = 1:l_o_Tripod
    Aequ(abs(o_Tripod(i_o_tripod,1)) + l_R, i_o_tripod + l_Bipod + l_Tripod) = ...
        Aequ(abs(o_Tripod(i_o_tripod,1)) + l_R, i_o_tripod + l_Bipod + l_Tripod) + ...
        sign_help(o_Tripod(i_o_tripod,1));
%%%%managed to do the open part... now other part.

Aequ(abs(o_Tripod(i_o_tripod,2)), i_o_tripod + l_Bipod + l_Tripod) = ...
  Aequ(abs(o_Tripod(i_o_tripod,2)), i_o_tripod + l_Bipod + l_Tripod) + ...
    sign_help(o_Tripod(i_o_tripod,2));

%%%%still missing the rectangles corresponding to the two open sides:
sign_rectangle_pair_temp = sign_help(o_Tripod(i_o_tripod,1));
rectangle_pair_temp = RP(abs(o_Tripod(i_o_tripod,1)),:);
%%%now fill in the conditions for those pairs!
Aequ(rectangle_pair_temp(1),i_o_tripod + l_Bipod + l_Tripod) = ...
    Aequ(rectangle_pair_temp(1),i_o_tripod + l_Bipod + l_Tripod) + ...
       rectangle_pair_temp(2)/2; %%%has only half the sign since other half yet to come to it.
                %%%%STOLPER: CHANGED THAT THE SIGN OF THE RECTANGLE PAIR
                %%%%DOES NOT AFFECT THE SIGN OF THE RECTANGLES.
            

Aequ(rectangle_pair_temp(3),i_o_tripod + l_Bipod + l_Tripod) = ...
    Aequ(rectangle_pair_temp(3),i_o_tripod + l_Bipod + l_Tripod) + ...
       rectangle_pair_temp(4)/2; %%%has only half the sign since other half yet to come to it.
   
end


%%%%%now:Conditions for Double Open Tripods


for i_do_Tripod = 1:l_do_Tripod
    %%%%first: put in the open side condition:
    o_side1 = abs(do_Tripod(i_do_Tripod,1));
    s_side1 = sign_help(do_Tripod(i_do_Tripod,1));
    o_side2 = abs(do_Tripod(i_do_Tripod,2));
    s_side2 = sign_help(do_Tripod(i_do_Tripod,2));
    
    %%%%put in the conditions for the open sides:
    Aequ(o_side1+l_R, i_do_Tripod + l_Bipod+ l_Tripod + l_o_Tripod) = ...
        Aequ(o_side1+l_R, i_do_Tripod + l_Bipod+ l_Tripod + l_o_Tripod) + s_side1;
    
    
    Aequ(o_side2+l_R, i_do_Tripod + l_Bipod+ l_Tripod + l_o_Tripod) = ...
        Aequ(o_side2+l_R, i_do_Tripod + l_Bipod+ l_Tripod + l_o_Tripod) + s_side2;
    
    

    
    
%%%%%now: put in the missing sides for the rectangles!
rp1_temp = RP(o_side1,:);
rp2_temp = RP(o_side2,:);

%%%%Flip sides depending on the sign:
if s_side1<0
    rp1_temp = rectangle_pair_flip(rp1_temp);
end

if s_side2<0
    rp2_temp = rectangle_pair_flip(rp2_temp);
end



%%%now fill in the conditions for the rectangles
Aequ(rp1_temp(1),i_do_Tripod + l_Bipod + l_Tripod+l_o_Tripod) = ...
    Aequ(rp1_temp(1),i_do_Tripod + l_Bipod + l_Tripod+l_o_Tripod) + ...
       rp1_temp(2)/2; %%%has only half the sign since other half yet to come to it.
   


Aequ(rp2_temp(3),i_do_Tripod + l_Bipod + l_Tripod+l_o_Tripod) = ...
    Aequ(rp2_temp(3),i_do_Tripod + l_Bipod + l_Tripod+l_o_Tripod) + ...
       rp2_temp(4)/2;
end

%%%%Hence: Aequ is almost ready.

%%%%next:insert condition that signed degree adds up to wordlength.

%for bipods
for i_bipod=1:l_Bipod
    Aequ(l_R+l_RP+1,i_bipod) = rectangle_sign(abs(Bipod(i_bipod,1)),R) + ...
        rectangle_sign(abs(Bipod(i_bipod,2)),R);
end

%for tripods
for i_tripod=1:l_Tripod
    Aequ(l_R+l_RP+1,i_tripod+l_Bipod) = ...
        rectangle_sign(abs(Tripod(i_tripod,1)),R) + ...
        rectangle_sign(abs(Tripod(i_tripod,2)),R) + ...
        rectangle_sign(abs(Tripod(i_tripod,3)),R);
end

%for open tripods
for i_o_tripod=1:l_o_Tripod
    Aequ(l_R+l_RP+1,i_o_tripod+l_Bipod+l_Tripod) = o_tripod_sign(i_o_tripod, o_Tripod,R, RP);
end


%for double open tripods
for i_do_Tripod=1:l_do_Tripod
    Aequ(l_R+l_RP+1,i_do_Tripod+l_Bipod+l_Tripod+l_o_Tripod) = ...
 do_Tripod_sign(i_do_Tripod,do_Tripod,R,RP);
end
%%%%done with Matrix A!!

%%%%do b_equ condition: 
bequ = zeros(l_R+l_RP+1,1);
bequ(l_R+l_RP+1,1) = wordlength;


%%%%still need to do: maximizing function f and matrix b.

lb = zeros(h_size_matrix,1);

l_max = zeros(l_Bipod + l_Tripod + l_o_Tripod + l_do_Tripod, 1);
%%%%fill in the maximizing function. Bipods have value -2/wordlength;
%%%%Tripods have  1/2 - 3/wordlength; 
%%%%open Tripods have 1/2 - 2/wordlength;
%%%%double open Tripods have 1 - 1/wordlength;



for i=1:l_Bipod
    if l1==1
        l_max(i) = -2/wordlength;
    else
        l_max(i) = 0;
    end
end
for i=(l_Bipod+1):(l_Bipod+l_Tripod)
    if l1==1
        l_max(i) = 1/2 -3/wordlength;
    else
        l_max(i)= 1/2;
    end
end
for i=(l_Bipod+l_Tripod + 1):(l_Bipod+l_Tripod+l_o_Tripod)
    if l1 == 1
        l_max(i) = 1/2 -2/wordlength;
    else
        l_max(i) = 1/2;
    end
end
for i=(l_Bipod+l_Tripod + l_o_Tripod + 1):(l_Bipod+l_Tripod+l_o_Tripod + l_do_Tripod)
    if l1==1
        l_max(i) = 1/2 -1/wordlength;
    else
        l_max(i) = 1/2;
    end
end

end


function s = sign_help(n)
if n > 0
    s=1;
elseif n==0
    s=0;
else
    s=-1;
end
end