function Tripods = Tripods(Rectangles, wordlength)
%%%Computes all Tripods from the rectangles.
%%%Output at [a,b,c,0] where a,b,c are the oriented rectangles.

Tripods = [0,0,0,0];

s_l_rect = size(Rectangles);
l_rect = s_l_rect(1);
for i1=1:l_rect
   r1_temp = Rectangles(i1,:);
   for sign1=-1:2:1
        %%%for every rectangle r1_temp and orientation sign1:
    for i2 = (i1+1):l_rect
        r2_temp = Rectangles(i2,:);
        for sign2 = -1:2:1
        %%%Check if r2_temp with orientation sign2 is following r1_temp with
        %%%orientation sign1
            if(following_rectangle(r1_temp, sign1, r2_temp, sign2, wordlength)==1)
                %%%r2_temp with orientation sign2 follows r1_temp with
                %%%orienation sign1!
                %%%Check that you don't already have a proper bipod
                if(following_rectangle(r2_temp, sign2, r1_temp, sign1, wordlength)~=1)
                %%%hence: not a proper bipod!
                 for i3 = (i1+1):l_rect
                     r3_temp = Rectangles(i3,:);
                      for sign3 = -1:2:1
                       %%%Check if r3_temp with orientation sign3 is following r2_temp with
                        %%%orientation sign
                        
                        
                        if(following_rectangle(r2_temp, sign2, r3_temp, sign3, wordlength)==1)
                        
                            %%%%Now check if this closes up to a proper tripod!

                            
                            if(following_rectangle(r3_temp, sign3, r1_temp, sign1, wordlength)==1)
                                %%%%found proper tripod!
                        
               
                                tripod_temp = [sign1*i1, sign2*i2, sign3*i3,0];
                               Tripods = [Tripods;tripod_temp];
                            end
                        end
                      end
                 end
                end
            end
        end
    end
   end
end
      
Tripods = Tripods(2:end,:);

end