function o_Tripods = open_tripods(R,RP,wordlength)
    %%%compute all open tripods. They are of the form:
    %%%[rp, r,0,0] where rp is the rectangle pair and r is the rectangle so
    %%%that if rp = [r1, s1, r2, s2], then r follows r1, and r2 follows r.
    %%%if a rectangle pair has a negative sign it means that
    %%%-[r1,s1,r2,s2]=[r2,-s2,r1,-s1]
    
    o_Tripods = [0,0,0,0];
    

    
    %%%%determine dimensions.
    
    s_l_rp = size(RP);
    Number_RP = s_l_rp(1);
    s_l_rect = size(R);
    Number_R = s_l_rect(1);
    
    
    for rp=1:Number_RP
        for sign_rp = -1:2:1
            if sign_rp == -1
                rp_temp = rectangle_pair_flip(RP(rp,:));
            else 
                rp_temp = RP(rp,:);
            end
            %%%read off the information of the rectangles!
            rp_r1 = R(rp_temp(1),:);
            rp_s1 = rp_temp(2);
            rp_r2 = R(rp_temp(3),:);
            rp_s2 = rp_temp(4);
            %%%check if rp_temp matches up with a rectangle r?
            for r_pos = 1:Number_R
                for r_sign = -1:2:1
                r_temp = R(r_pos,:); %%% our rectangle
                %%%%now:check if r fits into the rectangle pair!
                if following_rectangle(rp_r1,rp_s1,r_temp,r_sign,wordlength)
                    if following_rectangle(r_temp,r_sign,rp_r2,rp_s2,wordlength)
                        o_Tripods = [o_Tripods; sign_rp*rp,r_sign*r_pos,0,0];
                %%%check if first rectangle of rectangle pair is followed
                %%%by correct rectangles
                    end
                end
                end
            end
        end
    end
    o_Tripods = o_Tripods(2:end,:);
end





function r_pair_flip = rectangle_pair_flip(r_pair)

r_pair_flip(1) = r_pair(3);
r_pair_flip(2) = r_pair(4);
r_pair_flip(3) = r_pair(1);
r_pair_flip(4) = r_pair(2);
end
